/*
	tf[^쐬eXgiAv
*/
import com.nttdocomo.ui.*;
import java.io.*;
import java.util.*;

// AFύXȂǂ̃R}hACeNX
class ukMusicItem {

	public static final int COMMAND_NONE = 0;
	public static final int COMMAND_NOTE = 1;
	public static final int COMMAND_REST = 2;
	public static final int COMMAND_PROG = 3;
	public static final int COMMAND_TEMP = 4;
	public static final int COMMAND_NOTEON = 8;
	public static final int COMMAND_NOTEOFF = 9;

	private int _time;
	private int _channel;

	private int _command;

	private int _length;

	private int[] _param = new int[4];

	public ukMusicItem() {

	}

	/**
	Rs[RXgN^
	*/
	public ukMusicItem(ukMusicItem src) {
		assign(src);
	}

	public void assign(ukMusicItem src) {

		_time = src._time;

		_channel = src._channel;

		_command = src._command;

		_length = src._length;

		for (int i = 0;i < _param.length;i++) {
			_param[i] = src._param[i];
		}

	}

	/**
	R}h쐬
	@param ano m[gԍ
	@param avelocity xVeB
	@param alength Ŝ̒
	@param @noteLength 

	@return 쐬ꂽR}hBsnull
	*/
	static ukMusicItem createNoteItem(int no, int velocity, int length, int noteLength) {

		if (no < 0 || no > 127 || velocity < 0 || velocity > 127 || length < 1 || noteLength < 1 || length < noteLength) {
			return null;
		}

		ukMusicItem item = new ukMusicItem();

		item._command = COMMAND_NOTE;
		item._length = length;

		item._param[0] = no;
		item._param[1] = velocity;
		item._param[2] = noteLength;

		return item;

	}

	public int getTime() {
		return _time;
	}

	public int getChannel() {
		return _channel;
	}

	public int getCommand() {
		return _command;
	}

	public int getLength() {
		return _length;
	}

	public int getNoteNo() {
		if (_command == COMMAND_NOTE || _command == COMMAND_NOTEON || _command == COMMAND_NOTEOFF) {
			return _param[0];
		} else {
			return 0;
		}
	}

	public int getVelocity() {
		if (_command == COMMAND_NOTE || _command == COMMAND_NOTEON || _command == COMMAND_NOTEOFF) {
			return _param[1];
		} else {
			return 0;
		}
	}

	public int getNoteLength() {
		if (_command == COMMAND_NOTE || _command == COMMAND_NOTEON || _command == COMMAND_NOTEOFF) {
			return _param[2];
		} else {
			return 0;
		}
	}

	public int getProgNo() {
		if (_command == COMMAND_PROG) {
			return _param[0];
		} else {
			return 0;
		}
	}

	public int getParam(int index) {
		return _param[index];
	}

	public boolean setTime(int time) {

		if (time < 0) {
			return false;
		}

		_time = time;

		return true;

	}

	public boolean setChannel(int ch) {

		if (ch < 0 || ch > 3) {
			return false;
		}

		_channel = ch;

		return true;

	}

	public boolean setCommand(int cmd) {

		_command = cmd;

		return true;

	}

	public boolean setLength(int length) {

		if (length < 0) {
			return false;
		}

		_length = length;

		return true;

	}

	public boolean setNoteNo(int no) {
		if (_command == COMMAND_NOTE || _command == COMMAND_NOTEON || _command == COMMAND_NOTEOFF) {

			_param[0] = no;

			return true;

		} else {
			return false;
		}
	}

	public boolean setVelocity(int velocity) {
		if (_command == COMMAND_NOTE || _command == COMMAND_NOTEON || _command == COMMAND_NOTEOFF) {

			_param[1] = velocity;

			return true;

		} else {
			return false;
		}
	}

	public boolean setNoteLength(int no) {
		if (_command == COMMAND_NOTE || _command == COMMAND_NOTEON || _command == COMMAND_NOTEOFF) {

			_param[2] = no;

			return true;

		} else {
			return false;
		}
	}

	public boolean setProgNo(int no) {
		if (_command == COMMAND_PROG) {

			_param[0] = no;

			return true;

		} else {
			return false;
		}
	}

	public boolean setParam(int index, int val) {

		if (index < 0 || index >= _param.length) {
			return false;
		}

		_param[index] = val;

		return true;

	}

	// fobOp쐬
	public String toString() {

		String str = "ch:" + _channel;

		str += " time:" + _time;

		str += " length:" + _length;

		switch (_command) {

		case COMMAND_NOTE:

			str += " command:NOTE";

			break;

		case COMMAND_REST:

			str += " command:REST";

			break;

		case COMMAND_PROG:

			str += " command:PROG";

			break;

		}

		return str;

	}

}

// `l̃R}hێgbNNX
class ukMusicTrack {

	public ukMusicItem[] _items;
	public int _capacity;
	public int _index;
	public int[] _channelTime;

	private static final int DEFAULT_CAPACITY = 1024;

	public ukMusicTrack() {

		_channelTime = new int[4];

		_items = new ukMusicItem[DEFAULT_CAPACITY];

		if (_items == null) {
			return;
		}

		_capacity = DEFAULT_CAPACITY;

	}

	/**
	w`lɃR}hǉ

	@param ch `lԍ
	@param item ǉR}h

	@return trueAsfalse
	*/
	public boolean addItem(int ch, ukMusicItem item) {

		if (ch < 0 || ch > 3 || item == null) {
			return false;
		}

		if (_index >= _capacity) {

			int capacity = _capacity * 2;

			ukMusicItem[] items = new ukMusicItem[capacity];

			if (items == null) {
				return false;
			}

			for (int i = 0;i < _index;i++) {
				items[i] = _items[i];
			}

			_items = items;

		}

		ukMusicItem mi = new ukMusicItem(item);

		mi.setChannel(ch);
		mi.setTime(_channelTime[ch]);

		_items[_index++] = mi;

		_channelTime[ch] += mi.getLength();

		return true;

	}

	/**
	FύXivO`FWjǉ

	@param ch `lԍ
	@param prog Fԍ

	@return trueAsfalse
	*/
	public boolean changeProg(int ch, int prog) {

		ukMusicItem item = new ukMusicItem();

		item.setCommand(ukMusicItem.COMMAND_PROG);
		item.setProgNo(prog);

		return addItem(ch, item);

	}

	/**
	im[gI^m[gItjǉ

	@param ch `lԍ
	@param no m[gԍ
	@param velocity ̋
	@param length R}hŜ̎
	@param noteLength 

	@return trueAsfalse
	*/
	public boolean addNote(int ch, int no, int velocity, int length, int noteLength) {

		ukMusicItem item = ukMusicItem.createNoteItem(no, velocity, length, noteLength);

		if (item == null) {
			return false;
		}

		return addItem(ch, item);

	}

	/**
	xǉ

	@param ch `lԍ
	@param length 

	@return trueAsfalse
	*/
	public boolean addRest(int ch, int length) {

		if (length < 1) {
			return false;
		}

		ukMusicItem item = new ukMusicItem();

		item.setCommand(ukMusicItem.COMMAND_REST);
		item.setLength(length);

		return addItem(ch, item);

	}

	/**
	ێĂR}hz񂩂SMFgbNf[^쐬

	@return SMF`̃gbNf[^Bf[^쐬łȂnull
	*/
	public byte[] getSMFTrack() {

		if (_index < 1) {
			return null;
		}

		Vector tmpArray = new Vector();

		ukMusicItem item = new ukMusicItem();

		// R}hm[gI^m[gItōč\
		for (int i = 0;i < _index;i++) {

			item.assign(_items[i]);

			switch (item.getCommand()) {

			case ukMusicItem.COMMAND_PROG:

				tmpArray.addElement(new ukMusicItem(item));

				break;

			case ukMusicItem.COMMAND_NOTE:

				// m[gIR}h
				item.setCommand(ukMusicItem.COMMAND_NOTEON);

				tmpArray.addElement(new ukMusicItem(item));

				// m[gItR}h
				item.setCommand(ukMusicItem.COMMAND_NOTEOFF);
				item.setTime(item.getTime() + _items[i].getNoteLength());
				item.setVelocity(0);

				tmpArray.addElement(new ukMusicItem(item));

				break;

			}

		}

		ukMusicItem[] items = new ukMusicItem[tmpArray.size()];

		for (int i = 0;i < items.length;i++) {
			items[i] = (ukMusicItem)tmpArray.elementAt(i);
		}

		ByteArrayOutputStream buf = new ByteArrayOutputStream();

		int time = 0;

		while (true) {

			int nexttime = 0x7fffffff;
			int nextindex = -1;

			// ɏ鎞ԍŏ̃R}h
			for (int i = 0;i < items.length;i++) {
				if (items[i] != null && items[i].getTime() < nexttime) {

					nexttime = items[i].getTime();
					nextindex = i;

				}
			}

			if (nextindex < 0) {
				break;
			}

			// 񏈗R}h̎ԂƑO񏈗̎Ԃf^^CZo
			int dtime = items[nextindex].getTime() - time;

			// f^^Cϒ\
			byte[] dtimes = getNumBytes(dtime);

			switch (items[nextindex].getCommand()) {

			// vO`FW
			case ukMusicItem.COMMAND_PROG:

				byte cmdProg = (byte)((0xC0 | ((items[nextindex].getChannel()) & 0x0f)) & 0xff);

				for (int i = 0;i < dtimes.length;i++) {
					buf.write(dtimes[i]);
				}

				buf.write(cmdProg);
				buf.write((byte)(items[nextindex].getProgNo()));

				break;

			// m[gI^m[gIt
			case ukMusicItem.COMMAND_NOTEON:
			case ukMusicItem.COMMAND_NOTEOFF:

				byte cmdNote = 0;

				if (items[nextindex].getCommand() == ukMusicItem.COMMAND_NOTEON) {
					cmdNote = (byte)((0x90 | ((items[nextindex].getChannel()) & 0x0f)) & 0xff);
				} else {
					cmdNote = (byte)((0x80 | ((items[nextindex].getChannel()) & 0x0f)) & 0xff);
				}

				byte no = (byte)(items[nextindex].getNoteNo() & 0x7f);
				byte velocity = (byte)(items[nextindex].getVelocity() & 0x7f);

				// R}h
				try {

					for (int i = 0;i < dtimes.length;i++) {
						buf.write(dtimes[i]);
					}

					buf.write(cmdNote);
					buf.write(no);
					buf.write(velocity);

				} catch (Exception e) {
				}

				break;

			case ukMusicItem.COMMAND_REST:

				break;

			}

			time += dtime;

			// 񏈗R}hnull
			items[nextindex] = null;

		}

		// gbNI[
		try {

			buf.write(0);
			buf.write(0xff);
			buf.write(0x2f);
			buf.write(0);

		} catch (Exception e) {
		}

		byte[] data = null;

		// obt@zɏo
		try {
			data = buf.toByteArray();
		} catch (Exception e) {
		}

		return data;

	}

	/**
	ێĂR}hz񂩂mldgbNf[^쐬

	@return mld`̃gbNf[^Bf[^쐬łȂnull
	*/
	public byte[] getMLDTrack() {

		if (_index < 1) {
			return null;
		}

		ukMusicItem[] items = new ukMusicItem[_index];

		for (int i = 0;i < _index;i++) {
			items[i] = new ukMusicItem(_items[i]);
		}

		ByteArrayOutputStream buf = new ByteArrayOutputStream();

		int time = 0;

		while (true) {

			int nexttime = 0x7fffffff;
			int nextindex = -1;

			// ɏ鎞ԍŏ̃R}h
			for (int i = 0;i < _index;i++) {
				if (items[i] != null && items[i].getTime() < nexttime) {

					nexttime = items[i].getTime();
					nextindex = i;

				}
			}

			if (nextindex < 0) {
				break;
			}

			// 񏈗R}h̎ԂƑO񏈗̎Ԃf^^CZo
			int dtime = items[nextindex].getTime() - time;

			// bZ[W𑗂`lݒ
			byte ch = (byte)(((items[nextindex].getChannel() & 0xff) << 6) & 0xff);

			switch (items[nextindex].getCommand()) {

			// vO`FW
			case ukMusicItem.COMMAND_PROG:

				buf.write(dtime);
				buf.write(0xff);
				buf.write(0xe0);

				byte prog1 = (byte)(items[nextindex].getProgNo() & 0x3f);

				buf.write((byte)(ch | prog1));

				buf.write(0);
				buf.write(0xff);
				buf.write(0xe1);

				byte prog2 = 0;

				if (items[nextindex].getProgNo() > 63) {
					prog2 = 3;
				} else {
					prog2 = 2;
				}

				buf.write((byte)(ch | prog2));

				break;

			// 
			case ukMusicItem.COMMAND_NOTE:

				byte no = (byte)(ch | (byte)(items[nextindex].getNoteNo()));
				byte velocity = (byte)(items[nextindex].getVelocity() & 0xff);
				byte length = (byte)(items[nextindex].getNoteLength() & 0xff);

				// ^C^X[
				if (items[nextindex].getNoteLength() >= items[nextindex].getLength()) {
					length = (byte)((items[nextindex].getLength() + 1) & 0xff);
				}

				// MIDĨm[gԍmld̃m[gԍ
				no -= 33;

				// IN^[uVtg
				byte os = 0;

				if (no < 0) {
					if (no >= -12) {

						os = 1;

						no += 12;

					}
				}

				if (no > 0x3e) {
					if ((no - 0x3e) < 24) {
						if ((no - 0x3e) < 12) {

							no -= 12;
							os = 3;

						} else {

							no -= 24;
							os = 2;

						}
					}
				}

				// MIDĨxVeBi7rbgjmld̃xVeBi6rbgj
				velocity /= 2;

				byte st2 = (byte)((((velocity & 0xff) << 2) & 0xff) | os);

				try {

					buf.write(dtime);
					buf.write(no);
					buf.write(length);
					buf.write(st2);

				} catch (Exception e) {
				}

				break;

			}

			time += dtime;

			// 񏈗R}hnull
			items[nextindex] = null;

		}

		try {

			buf.write(0x30);
			buf.write(0xff);
			buf.write(0xdf);
			buf.write(0);

		} catch (Exception e) {
		}

		byte[] data = null;

		try {
			data = buf.toByteArray();
		} catch (Exception e) {
		}

		return data;

	}

	/**
	f^^CȂMIDIf[^p8i7jrbgϒl\擾

	@param val ϊl
	@return ϊ
	*/
	private byte[] getNumBytes(int val) {

		int bit = 0;

		// rbgZo
		for (int i = 0;i < 30;i++) {
			if ((val & ((1 << i))) != 0) {
				bit = i + 1;
			}
		}

		int size = 1;

		if (bit > 0) {
			size = 1 + ((bit - 1) / 7);
		}

		byte[] bytes = new byte[size];

		for (int i = bytes.length - 1 ;i >= 0;i--) {

			bytes[i] = (byte)((val & 0x7f) & 0xff);
			val = val >> 7;

			if (i != bytes.length - 1) {
				bytes[i] |= (byte)0x80;
			}

		}

		return bytes;

	}

}

class ukMusicData {

	private ukMusicTrack _track;

	private String _title;
	private String _copyright;

	public ukMusicData() {
		initTrack();
	}

	public void initTrack() {

		_track = new ukMusicTrack();

	}

	public ukMusicTrack getTrack() {
		return _track;
	}

	/*
	ێĂgbNSMF`̃oCif[^쐬

	@return SMF`̃oCif[^
	*/
	public byte[] getSMF() {

		if (_track == null) {
			return null;
		}

		byte[] smf = null;

		byte[] header = null;
		byte[] track = null;

		ByteArrayOutputStream infobuf = new ByteArrayOutputStream();

		try {

			infobuf.write("MThd".getBytes());

			// wb_TCY6
			infobuf.write(0);
			infobuf.write(0);
			infobuf.write(0);
			infobuf.write(6);

			// tH[}bg0
			infobuf.write(0);
			infobuf.write(0);

			// gbN1
			infobuf.write(0);
			infobuf.write(1);

			// l̒48
			infobuf.write(0);
			infobuf.write(0x30);

			header = infobuf.toByteArray();

		} catch (Exception e){}

		// gbNf[^擾
		byte[] trackData = _track.getSMFTrack();

		if (trackData == null || trackData.length < 1) {
			return null;
		}

		ByteArrayOutputStream trackbuf = new ByteArrayOutputStream();

		try {

			trackbuf.write("MTrk".getBytes());

			// f[^TCY0Ŗ߂
			trackbuf.write(0);
			trackbuf.write(0);
			trackbuf.write(0);
			trackbuf.write(0);

			// gbNf[^
			trackbuf.write(trackData);

			track = trackbuf.toByteArray();

		} catch (Exception e){}

		if (track == null) {
			return null;
		}

		// gbÑf[^TCY
		track[7] = (byte)((trackData.length & 0x000000ff) & 0xff);
		track[6] = (byte)(((trackData.length & 0x0000ff00) >> 8) & 0xff);
		track[5] = (byte)(((trackData.length & 0x00ff0000) >> 16) & 0xff);
		track[4] = (byte)(((trackData.length & 0xff000000) >> 24) & 0xff);

		ByteArrayOutputStream smfbuf = new ByteArrayOutputStream();

		try {

			smfbuf.write(header);
			smfbuf.write(track);

			smf = smfbuf.toByteArray();

		} catch (Exception e){}

		return smf;

	}

	/*
	ێĂgbNmld`̃oCif[^쐬

	@return mld`̃oCif[^
	*/
	public byte[] getMLD() {

		if (_track == null) {
			return null;
		}

		byte[] header = new byte[13];
		byte[] info = null;
		byte[] trackhead = new byte[8];
		byte[] track = null;

		ByteArrayOutputStream infobuf = new ByteArrayOutputStream();

		try {

			byte[] name = "test".getBytes();

			infobuf.write("titl".getBytes());
			infobuf.write((byte)((name.length & 0xff00) >> 8));
			infobuf.write((byte)(name.length & 0xff));
			infobuf.write(name);

			infobuf.write("vers".getBytes());
			infobuf.write(0);
			infobuf.write(4);
			infobuf.write(0x30);
			infobuf.write(0x33);
			infobuf.write(0x31);
			infobuf.write(0x30);

			infobuf.write("sorc".getBytes());
			infobuf.write(0);
			infobuf.write(1);
			infobuf.write(0);

			infobuf.write("note".getBytes());
			infobuf.write(0);
			infobuf.write(2);
			infobuf.write(0);
			infobuf.write(1);

			infobuf.close();

			info = infobuf.toByteArray();

		} catch (Exception e){}

		track = _track.getMLDTrack();

		int trackLength = track.length;

		trackhead[0] = 0x74;
		trackhead[1] = 0x72;
		trackhead[2] = 0x61;
		trackhead[3] = 0x63;

		trackhead[7] = (byte)((trackLength & 0x000000ff) & 0xff);
		trackhead[6] = (byte)(((trackLength & 0x0000ff00) >> 8) & 0xff);
		trackhead[5] = (byte)(((trackLength & 0x00ff0000) >> 16) & 0xff);
		trackhead[4] = (byte)(((trackLength & 0xff000000) >> 24) & 0xff);

		header[0] = 0x6d;
		header[1] = 0x65;
		header[2] = 0x6c;
		header[3] = 0x6f;

		int dataLength = 13 + info.length + track.length;

		// f[^
		header[7] = (byte)((dataLength - 8) & 0xff);
		header[6] = (byte)((((dataLength - 8) & 0x0000ff00) >> 8) & 0xff);
		header[5] = (byte)((((dataLength - 8) & 0x00ff0000) >> 16) & 0xff);
		header[4] = (byte)((((dataLength - 8) & 0xff000000) >> 24) & 0xff);

		int trackOffset = info.length + 3;

		// gbN܂ł̃ItZbg
		header[9] = (byte)(trackOffset & 0xff);
		header[8] = (byte)(((trackOffset & 0x0000ff00) >> 8) & 0xff);

		// f[^^Cv
		header[10] = 2;
		header[11] = 1;

		// gbN
		header[12] = 1;

		ByteArrayOutputStream mldbuf = new ByteArrayOutputStream();
		byte[] mld = null;

		try {

			mldbuf.write(header);
			mldbuf.write(info);
			mldbuf.write(trackhead);
			mldbuf.write(track);

			mldbuf.close();

			mld = mldbuf.toByteArray();

		} catch (Exception e){}

		return mld;

	}

}

class testCanvas extends Canvas {

	public void test() {

		// yȃf[^NX쐬
		ukMusicData data = new ukMusicData();

		// yȃR}hǉ
		data.getTrack().changeProg(0, 42); // Fݒ
		data.getTrack().addNote(0, 60, 122, 48, 40); // h
		data.getTrack().addNote(0, 62, 122, 48, 40); // 
		data.getTrack().addNote(0, 64, 122, 48, 40); // ~
		data.getTrack().addNote(0, 65, 122, 48, 40); // t@
		data.getTrack().addNote(0, 67, 122, 48, 40); // \
		data.getTrack().addNote(0, 69, 122, 48, 40); // 
		data.getTrack().addNote(0, 71, 122, 48, 40); // V
		data.getTrack().addNote(0, 72, 122, 48, 40); // h
		data.getTrack().addRest(0, 96); // x
		data.getTrack().changeProg(0, 59); // Fݒ
		data.getTrack().addNote(0, 72, 122, 48, 40);
		data.getTrack().addNote(0, 71, 122, 48, 40);
		data.getTrack().addNote(0, 69, 122, 48, 40);
		data.getTrack().addNote(0, 67, 122, 48, 40);
		data.getTrack().addNote(0, 65, 122, 48, 40);
		data.getTrack().addNote(0, 64, 122, 48, 40);
		data.getTrack().addNote(0, 62, 122, 48, 40);
		data.getTrack().addNote(0, 60, 122, 48, 40);

		data.getTrack().changeProg(1, 49); // Fݒ
		data.getTrack().addNote(1, 48, 70, 192, 192);
		data.getTrack().addNote(1, 55, 70, 192, 192);
		data.getTrack().addRest(1, 96); // x
		data.getTrack().addNote(1, 55, 70, 192, 192);
		data.getTrack().addNote(1, 48, 70, 192, 192);

		data.getTrack().changeProg(2, 0); // Fݒ
		data.getTrack().addNote(2, 72, 122, 192, 192); // h
		data.getTrack().addNote(2, 72, 122, 192, 192); // h
		data.getTrack().addNote(2, 60, 122, 24, 20); // h
		data.getTrack().addNote(2, 62, 122, 24, 20); // 
		data.getTrack().addNote(2, 64, 122, 24, 20); // ~
		data.getTrack().addNote(2, 65, 122, 24, 20); // t@

		// mldf[^쐬
		byte[] mld = data.getMLD();

		// MediaSoundIuWFNg쐬
		MediaSound ms = MediaManager.getSound(mld);

		try {
			ms.use();
		} catch (Exception e) {
			System.out.println(e);
		}

		// ĐpAudioPresenter쐬
		AudioPresenter ap = AudioPresenter.getAudioPresenter();

		// MediaSoundZbgčĐ
		ap.setSound(ms);
		ap.play();

	}

	public void paint(Graphics g) {

	}

}

public class io0802i extends IApplication {

	public void start() {

		testCanvas cv = new testCanvas();

		Display.setCurrent(cv);

		cv.test();

	}

}
